/*
Uebersetzen des Codes unter Linux:
gcc -o anisotropic anisotropic.cpp glfont.c -lMesaGLU -lMesaGL -lXext -lX11 -lm -lglut -lXi -lXmu -B/usr/X11/lib
*/


#ifdef OS_WIN32
#   include <windows.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <GL/glut.h>
extern "C" {
#  include "glfont.h"
}


#ifndef GL_EXT_texture_filter_anisotropic
#   error GL_EXT_texture_filter_anisotropic not supported on this system - sorry.
#endif

GLFONT fnt_antiqua20bf;
float  zk=0.0;
float  max_anisotropy;
float  anisotropy = 1.0;
int    filter[] = { GL_NEAREST, GL_LINEAR, GL_NEAREST_MIPMAP_NEAREST,
                    GL_NEAREST_MIPMAP_LINEAR, GL_LINEAR_MIPMAP_NEAREST,
		    GL_LINEAR_MIPMAP_LINEAR 
                  };
char   filterstr[][26] = { "GL_NEAREST", 
			   "GL_LINEAR", 
                           "GL_NEAREST_MIPMAP_NEAREST",
			   "GL_NEAREST_MIPMAP_LINEAR",
			   "GL_LINEAR_MIPMAP_NEAREST",
			   "GL_LINEAR_MIPMAP_LINEAR" 
                         };

int    minFilter=5;
int    magFilter=1;
char   text[][35] = {"Erweiterungen des OpenGL Standards",
		     "sind Segen und Fluch zugleich.    ",
                     " ",
                     " ",
		     "Einerseits    ermoeglichen    sie ", 
                     "Schnittstellen  zur  Nutzung  spe-",
                     "zieller  Hardware   Features   wie", 
		     "Bewegttexturen  aus   Videoquellen",
                     "oder  Pixelshadern,  andererseits ",
		     "erschwert  ihr  Einsatz  die  Por-",
		     "tierung von  OpenGL Programmen auf",
		     "verschiedene Plattformen.",
                     "Gluecklicherweise  gibt   es  eine",
                     "ganze   Reihe  von  Erweiterungen,",
                     "ueber  die  unter  den Herstellern",
                     "breites Einvernehmen  herrscht, so",
		     "dass sie fuer die meisten Betriebs",
		     "systeme implementiert sind.",
                     ""};

static void Init(void)
{
  glGetFloatv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, &max_anisotropy);

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_BLEND);
  glFontCreateASCII (&fnt_antiqua20bf, "antiqua_20_bf.fnt", 1, TRUE,
                    filter[minFilter], filter[magFilter]);
}


static void OnReshape(int width, int height)
{
  glViewport(0, 0, (GLint)width, (GLint)height);
  glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90.0, 1.0, 1.0, 200.0);
  glMatrixMode(GL_MODELVIEW);
}

static void OnKey(unsigned char key, int x, int y)
{
  switch (key) {
  case 27:
  case 'q':
    exit(1);
  case 'A':
  case 'a':
    if (anisotropy==1.0)
      anisotropy=max_anisotropy;
    else 
      anisotropy=1.0;

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, anisotropy);
    break;
  case '-':
    minFilter = (minFilter +1) %6;

    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, filter[minFilter]);
    break;
  case '+':
    magFilter = (magFilter +1) %2;

    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, filter[magFilter]);
    break;
  default:
    break;
  }
  glutPostRedisplay();
}

static void OnDisplay(void)
{
  short ln;
  char lnBuffer[80];

  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glLoadIdentity ();

  glScalef (0.4, 0.4 , 0.4);

  glPushMatrix();
   glScalef (0.1, 0.2 , 1.0);
   glColor3f (1.0, 0.4, 0.4);
   glEnable (GL_TEXTURE_2D);
    glFontBegin (&fnt_antiqua20bf);
      sprintf (lnBuffer, "(-) GL_MIN_FILTER : %s", filterstr[minFilter]);
      glFontTextOut (lnBuffer, -40, 20, -4);
      sprintf (lnBuffer, "(+) GL_MAG_FILTER: %s", filterstr[magFilter]);
      glFontTextOut (lnBuffer, -40, 17, -4);
      sprintf (lnBuffer, "(a) MAX_ANISOTROPY_EXT: %2.2f", anisotropy);
      glFontTextOut (lnBuffer, -40, 14, -4);
    glFontEnd ();
  glPopMatrix();

  glColor3f (0.8, 1.0, 0.8);
  glRotatef (30, 1.0, 0.0, 0.0);     /* Kamera schwenken        */
  glTranslatef (-18.0, -18.0, -2-zk); 
  glRotatef (-90, 1.0, 0.0, 0.0);    /* Font in XZ-Ebene drehen */

  glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glEnable (GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  glFontBegin (&fnt_antiqua20bf);
    ln=0;
    while (text[ln][0]) {
      glFontTextOut (text[ln], 0, 3-2.8*(float)ln,0);
      ln++;
    }
  glFontEnd ();

  glutSwapBuffers();
}

void OnIdle ()
{
   zk += 0.005;
   if (zk>100)
      zk=0.0;

   OnDisplay();
}

int main(int argc, char **argv)
{
  char *s;

  glutInit(&argc, argv);
  glutInitWindowPosition(0, 0);
  glutInitWindowSize( 800, 600);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE);

  if (glutCreateWindow("TextureFont Demo") == GL_FALSE)
    exit(1);

  Init();

  glutReshapeFunc(OnReshape);
  glutKeyboardFunc(OnKey);
  glutDisplayFunc(OnDisplay);
  glutIdleFunc(OnIdle);

  s = (char *)glGetString (GL_EXTENSIONS);
  /* ACHTUNG - der folgende Test ist im Ernstfall nicht hinreichend */
  if (strstr (s, "GL_EXT_texture_filter_anisotropic")==NULL) {
    fprintf (stderr, "Sorry, your OpenGL library does not support the necessary extention.\n");
    exit (0);
  }

  glutMainLoop();
}
